﻿using System;

namespace EventsTest
{
    public delegate void FirstEventHandler();
    public delegate void SecondEventHandler();

    public class EventsClass
    {
        public event FirstEventHandler FirstEvent;
        public event SecondEventHandler SecondEvent;

        private void FireOffFirstEvent()
        {
            FirstEvent();
        }

        private void FireOffSecondEvent()
        {
            SecondEvent();
        }

        public void FireOffAllEvents()
        {
            FireOffFirstEvent();
            FireOffSecondEvent();
        }
    }

    public class EntryClass
    {
        static void Main()
        {
            EventsClass MyEvents = new EventsClass();
            string MyChoice;

            do
            {
                Console.Write("Do you wish to register the event clients to the events? (y/n): ");
                MyChoice = Console.ReadLine();

            } while (MyChoice != "y" && MyChoice != "n");

            switch (MyChoice)
            {
                case "y":

                    MyEvents.FirstEvent += new FirstEventHandler(FirstEventClient);
                    Console.WriteLine("First event registered.");

                    MyEvents.SecondEvent += new SecondEventHandler(SecondEventClient);
                    Console.WriteLine("Second event registered.");

                    break;

                case "n":

                    Console.WriteLine("No events registered.");

                    break;
            }

            Console.WriteLine("Firing off all events..");

            MyEvents.FireOffAllEvents();

            Console.WriteLine("Press enter to continue..");
            Console.ReadLine();
        }

        static void FirstEventClient()
        {
            Console.WriteLine("First event processed successfully.");
        }

        static void SecondEventClient()
        {
            Console.WriteLine("Second event processed successfully.");
        }
    }
}

